Attribute VB_Name = "InserisciNewCampiTabelle"
Option Explicit
Dim Stringa As String

' http://www.functionx.com/ado/Lesson06.htm

'************************************************************
' il file deve intestarsi Info.txt
'************************************************************
'[Tabelle]
'NuovaTabella
'[Campi]
'NuovaTabella|ID|Counter|000|False            contatore
'NuovaTabella|Testo|VARCHAR|250|False         testo
'NuovaTabella|InteroLungo|Integer|000|False   Intero Lungo
'NuovaTabella|Booleanoano|bit|000|False       Boolean
'NuovaTabella|Lungoe|long|000|False           Double
'NuovaTabella|Bytew|Byte|000|False            byte
'NuovaTabella|Moneta|Currency|000|False       Currency
'NuovaTabella|MiaData|DateTime|000|False      DataOra
'NuovaTabella|Stringa2|string|40|False        Stringa
'NuovaTabella|Memoria|LongText|000|False      Memo
'************************************************************




'Public Sub Main()
'     CreaTabellaInsCampi App.Path & "\Provatipo.mdb"
'End Sub
 
 
 
Public Sub CreaTabellaInsCampi(ByVal NomeDatabase As String)
 
If Dir(App.Path & "\Info.txt") <> "" Then



Dim Tabelle(100, 1) As Variant
Dim Campi(200, 6) As Variant
Dim LeggiTabelle As Boolean
Dim I, M As Long
Open App.Path & "\Info.txt" For Input As #1
    Do While Not EOF(1)
        Line Input #1, Stringa
        
        If Stringa = "[Tabelle]" Then
        LeggiTabelle = True
        I = 0
        GoTo cambia
        ElseIf Stringa = "[Campi]" Then
         
        LeggiTabelle = False
        I = 0
        GoTo cambia
        End If
        
        If LeggiTabelle = True Then
            Tabelle(I, 0) = Stringa
            Tabelle(I, 1) = False
        Else
        Campi(I, 1) = Spezza(Stringa) ' tabella
        Campi(I, 2) = Spezza(Stringa) ' nome campo
        Campi(I, 3) = Spezza(Stringa) ' tipo
        Campi(I, 4) = Val(Spezza(Stringa)) ' lunghezza
        Campi(I, 5) = Spezza(Stringa) ' contatore
        Campi(I, 6) = False             ' se esiste viene messo true
        End If
        I = I + 1
cambia:
    Loop
 
Close #1


 Dim cnn As New ADODB.Connection
   Dim cat As New ADOX.Catalog
   Dim tbl As New ADOX.Table
   Dim col As New ADOX.Column

   cnn.Open "Provider=Microsoft.Jet.OLEDB.4.0; Data Source= " & NomeDatabase
   Set cat.ActiveConnection = cnn
       
       ' se la prima tabella  vuota  inutile farla andare avanti per
       ' la creazione della tabella
       
       If Tabelle(0, 0) <> "" Then
        ''verifica le tabelle
       For I = 0 To cat.Tables.Count - 1
        If cat.Tables(I).Type = "TABLE" And Mid(cat.Tables(I).Name, 1, 4) <> "MSYS" Then
             
                Debug.Print "tabella di servizio " & cat.Tables(I).Name
                For M = 0 To UBound(Tabelle)
                    If Len(Trim(Tabelle(M, 0))) > 0 Then
                        If UCase(Tabelle(M, 0)) = UCase(cat.Tables(I).Name) Then
                        ' SE ESISTE LA TABELLA LA METTE A TRUE
                        Tabelle(M, 1) = True
                        End If
                    Else
                    Exit For
                    End If
                Next

            End If
        Next
         
       End If
       
 Dim Z As Long
  
        '    crea le tabelle nuove
        For I = 0 To UBound(Tabelle) - 1
            If Len(Trim(Tabelle(I, 0))) > 0 Then
                If Tabelle(I, 1) = False Then
'                    cnn.Execute "CREATE TABLE " & Trim(Tabelle(I, 0)), 0, 0
             Set tbl = New ADOX.Table
            tbl.ParentCatalog = cat
            tbl.Name = Tabelle(I, 0)
            ' contatore autoincrement
            For Z = 0 To UBound(Campi) - 1
                If Campi(Z, 5) = "True" And Tabelle(I, 0) = Campi(Z, 1) Then
                  Set col = New ADOX.Column
                    col.ParentCatalog = cat
                    col.Type = ADOX.DataTypeEnum.adInteger
                    col.Name = Campi(Z, 2)
                    col.Properties("Jet OLEDB:Allow Zero Length").Value = False
                    col.Properties("AutoIncrement").Value = True
                    tbl.Columns.Append col, ADOX.DataTypeEnum.adInteger, 0
                    Exit For
                End If
              
              Next
              
              cat.Tables.Append tbl



                End If
            Else
             Exit For
            End If
         Next

' creazione Campi
For I = 0 To UBound(Campi) - 1
Debug.Print Campi(I, 1) & " " & Campi(I, 2)
    If Len(Trim(Campi(I, 1))) > 0 And Campi(I, 5) = "False" Then
        CreaCampo cnn, Campi(I, 1), Campi(I, 2), Campi(I, 3), Val(Campi(I, 4))
    ElseIf Len(Trim(Campi(I, 1))) = 0 Then
        Exit For
    End If
Next

' cancella il file in maniera che lo legge una sola volta.
 Kill App.Path & "\Info.txt"


End If





End Sub



Public Function CreaCampo(ByVal Connessione As Connection, ByVal NomeTabella As String, ByVal NomeCampo As String, ByVal TipoCampo As String, Optional Lungo As Long) As Boolean
On Error GoTo Errore

If Lungo <> 0 Then
TipoCampo = TipoCampo & "(" & Lungo & ")"
End If
If TipoCampo = "Counter" Then
Connessione.Execute "ALTER TABLE " & NomeTabella & " ADD COLUMN " & NomeCampo & " " & TipoCampo & ";"
Else
Connessione.Execute "ALTER TABLE " & NomeTabella & " ADD COLUMN " & NomeCampo & " " & TipoCampo & " NULL;"
End If
CreaCampo = True
Exit Function
Errore:
Err.Clear
CreaCampo = False

End Function



Private Function Spezza(ByVal Pezzo As String) As String
    Dim M As Long
    M = InStr(1, Pezzo, "|")
    If M > 0 Then
    Spezza = Mid(Pezzo, 1, M - 1)
    Stringa = Trim(Mid(Pezzo, M + 1, Len(Stringa)))
    Else
    Spezza = Pezzo
    Stringa = ""
        End If
End Function




'*********************************************************************************************
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN ID Counter;" ' Contatore
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova VARCHAR(255) NULL;" ' testo
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova2 Integer NULL;"    ' Intero lungo
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova3 bit NULL;"       ' boolean
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova4 long NULL;"       ' Intero lungo
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova5 Byte NULL;"       ' byte
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova6 Currency NULL;"       ' Currency
'''cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova7 DateTime NULL;"       ' Currency
''' cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN Prova9 string(43) NULL;"       ' Testo
''' cnn.Execute "ALTER TABLE Test_Table2 ADD COLUMN mNote LongText NULL;"       ' Memo
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''cnn.Close
'*********************************************************************************************


